
********************************************
PROCEDURE C2RGB(liColor,laColor)
LOCAL lcPom
lcPom=RIGHT(TRANSFORM(liColor,"@0"),6)
laColor(1)=VAL("0x"+RIGHT(lcPom,2))
laColor(2)=VAL("0x"+SUBST(lcPom,3,2))
laColor(3)=VAL("0x"+LEFT(lcPom,2))

***********************************************************************
*
***********************************************************************
DEFINE CLASS _bmp AS CUSTOM
   PROTECTED biSize,Size,Head,Offset,Reserved1,Reserved2,biSize,;
             biWidth,biHeight,biPlanes,biBitCount,biCompression,biSizeImage,;
             biXPelsPerMeter,biYPelsPerMeter,biClrUsed,biClrImportant,;
             ColorArray,Data,_Index

   Head=""
   Size=0
   Offset=0
   Reserved1=0
   Reserved2=0

   biSize=0 && DWORD  biSize
   biWidth=0 && LONG   biWidth 
   biHeight=0 &&  LONG   biHeight
   biPlanes=0 &&  WORD   biPlanes 
   biBitCount=0 &&  WORD   biBitCount
   biCompression=0 &&  DWORD  biCompression
   biSizeImage=0 &&  DWORD  biSizeImage
   biXPelsPerMeter=0 &&  LONG   biXPelsPerMeter
   biYPelsPerMeter=0 &&  LONG   biYPelsPerMeter
   biClrUsed=0 &&  DWORD  biClrUsed
   biClrImportant=0 &&  DWORD  biClrImportant

   ColorArray=""
   Data=""

   _Index=-1
   _Delta=0

   PROCEDURE ReadFromFile(lcFile)
      LOCAL lcPom,liStart
      lcPom=FILETOSTR(lcFile)

      *BITMAPFILEHEADER
      This.Head=SUBST(lcPom,1,2)
      This.Size=CTOBIN(SUBST(lcPom,3,4),"RS") && kompletn velikost BMP souboru
      This.Reserved1=CTOBIN(SUBST(lcPom,7,2),"2RS")
      This.Reserved2=CTOBIN(SUBST(lcPom,9,2),"2RS")
      This.Offset=CTOBIN(SUBST(lcPom,11,4),"RS") && Specifies the offset, in bytes, from the beginning of 
                         && the BITMAPFILEHEADER structure to the bitmap bits. 

      *BITMAPINFOHEADER
      This.biSize=CTOBIN(SUBST(lcPom,15,4),"RS") && DWORD  biSize
      This.biWidth=CTOBIN(SUBST(lcPom,19,4),"RS") && LONG   biWidth 
      This.biHeight=CTOBIN(SUBST(lcPom,23,4),"RS") &&  LONG   biHeight
      This.biPlanes=CTOBIN(SUBST(lcPom,27,2),"RS") &&  WORD   biPlanes 
      This.biBitCount=CTOBIN(SUBST(lcPom,29,2),"RS") &&  WORD   biBitCount
      This.biCompression=CTOBIN(SUBST(lcPom,31,4),"RS") &&  DWORD  biCompression
      This.biSizeImage=CTOBIN(SUBST(lcPom,35,4),"RS") &&  DWORD  biSizeImage
      This.biXPelsPerMeter=CTOBIN(SUBST(lcPom,39,4),"RS") &&  LONG   biXPelsPerMeter
      This.biYPelsPerMeter=CTOBIN(SUBST(lcPom,43,4),"RS") &&  LONG   biYPelsPerMeter
      This.biClrUsed=CTOBIN(SUBST(lcPom,47,4),"RS") &&  DWORD  biClrUsed
      This.biClrImportant=CTOBIN(SUBST(lcPom,51,4),"RS") &&  DWORD  biClrImportant

      This._Delta=4-This.biWidth%4
      This._Delta=IIF(This._Delta=4,0,This._Delta)

      * Pole barev
      IF This.biBitCount=8
         This._Index=256
         This.ColorArray=SUBST(lcPom,15+This.biSize,This._Index*4)
      ENDIF
      * Data
      This.Data=SUBST(lcPom,This.Offset+1)
   ENDPROC

   PROCEDURE GetIndexByColor(liR,liG,liB,liA)
      LOCAL liStart
      IF This.biBitCount>8
         RETURN -1
      ENDIF
      liStart=AT(CHR(liB)+CHR(liG)+CHR(liR)+CHR(liA),This.ColorArray)
      IF liStart=0
         liStart=AT(CHR(liB)+CHR(liG)+CHR(liR),This.ColorArray)
      ENDIF
      RETURN IIF(liStart=0,-1,INT((liStart-1)/4))
   ENDPROC

   PROCEDURE GetColorByIndex(liIndex)
      LOCAL liStart
      IF This.biBitCount>8
         RETURN -1
      ENDIF
      liStart=liIndex*4+1
      RETURN RGB(ASC(SUBST(This.ColorArray,liStart+2,1)),ASC(SUBST(This.ColorArray,liStart+1,1)),ASC(SUBST(This.ColorArray,liStart,1)))
   ENDPROC

   PROCEDURE SetColorByIndex(liIndex,liR,liG,liB,liA)
      IF This.biBitCount>8
         RETURN .F.
      ENDIF
      This.ColorArray=STUFF(This.ColorArray,liIndex*4+1,4,CHR(liB)+CHR(liG)+CHR(liR)+CHR(liA))
   ENDPROC

   PROCEDURE AddColor(liR,liG,liB,liA)
      LOCAL liIndex
      IF This.biBitCount>8
         RETURN -1
      ENDIF
      liIndex=This.GetIndexByColor(liR,liG,liB,liA)
      IF liIndex=-1 OR liIndex>This._Index
         STORE This._Index+1 TO This._Index,liIndex
         =This.SetColorByIndex(liIndex,liR,liG,liB,liA)
      ENDIF
      RETURN liIndex
   ENDPROC


   PROCEDURE GetPointColor(liY,liX,llIndex)
      LOCAL liLen,lcPom
      liLen=This.biBitCount/8
      lcPom=SUBSTR(This.Data,(liX-1)*liLen+1+(This.biHeight-liY)*(This.biWidth*liLen+This._Delta),liLen)

      RETURN IIF(liLen>1,;
                 IIF(liLen=2,CTOBIN(lcPom,"2S"),IIF(liLen=3,CTOBIN(CHR(0)+lcPom,"S"),CTOBIN(lcPom,"S"))),;
                 IIF(llIndex,ASC(lcPom),This.GetColorByIndex(ASC(lcPom))))
   ENDPROC


   PROCEDURE SetPointColor(liY,liX,liIndex,llIndex)
      LOCAL liLen,lcData,lcPom
      liLen=This.biBitCount/8
      IF liLen=1
         lcPom=IIF(!llIndex,SUBST(TRANSFORM(liIndex,"@0"),3),"")
         lcData=CHR(IIF(llIndex,liIndex,This.AddColor(VAL("0x"+RIGHT(lcPom,2)),VAL("0x"+SUBST(lcPom,5,2)),VAL("0x"+SUBST(lcPom,3,2)),0)))
      ELSE
         lcData=IIF(liLen=2,BINTOC(liIndex,"2S"),IIF(liLen=3,RIGHT(BINTOC(liIndex,"S"),3),BINTOC(liIndex,"S")))
      ENDIF
      This.Data=STUFF(This.Data,(liX-1)*liLen+1+(This.biHeight-liY)*(This.biWidth*liLen+This._Delta)  ,liLen, lcData )
   ENDPROC


   PROCEDURE PutVLine(liY,liX1,liX2,liIndex,llIndex)
      LOCAL liLen,lcData,lcPom
      liLen=This.biBitCount/8
      IF liX2<liX1 OR liX1<0 OR liX2>This.biWidth
         RETURN .F.
      ENDIF
      IF liLen=1
         lcPom=IIF(!llIndex,SUBST(TRANSFORM(liIndex,"@0"),3),"")
         lcData=CHR(IIF(llIndex,liIndex,This.AddColor(VAL("0x"+RIGHT(lcPom,2)),VAL("0x"+SUBST(lcPom,5,2)),VAL("0x"+SUBST(lcPom,3,2)),0)))
      ELSE
         lcData=IIF(liLen=2,BINTOC(liIndex,"2S"),IIF(liLen=3,RIGHT(BINTOC(liIndex,"S"),3),BINTOC(liIndex,"S")))
      ENDIF
      This.Data=STUFF(This.Data,(liX1-1)*liLen+1+(This.biHeight-liY)*(This.biWidth*liLen+This._Delta)  ,liLen*(liX2-liX1+1), REPL(lcData,liX2-liX1+1))
   ENDPROC

   PROCEDURE PutHLine(liX,liY1,liY2,liIndex,llIndex)
      LOCAL liLen,lcData,lii,lcPom
      liLen=This.biBitCount/8
      IF liY2<liY1 OR liY1<0 OR liY2>This.biHeight
         RETURN .F.
      ENDIF
      IF liLen=1
         lcPom=IIF(!llIndex,SUBST(TRANSFORM(liIndex,"@0"),3),"")
         lcData=CHR(IIF(llIndex,liIndex,This.AddColor(VAL("0x"+RIGHT(lcPom,2)),VAL("0x"+SUBST(lcPom,5,2)),VAL("0x"+SUBST(lcPom,3,2)),0)))
      ELSE
         lcData=IIF(liLen=2,BINTOC(liIndex,"2S"),IIF(liLen=3,RIGHT(BINTOC(liIndex,"S"),3),BINTOC(liIndex,"S")))
      ENDIF
      FOR lii=0 TO liY2-liY1
          This.Data=STUFF(This.Data,(liX-1)*liLen+1+(This.biHeight-(liY1+lii))*(This.biWidth*liLen+This._Delta)  ,liLen, lcData )
      NEXT
   ENDPROC



   PROCEDURE FillSolid(liY1,liY2, liX1,liX2, liColor)
      LOCAL liHeight,liWidth,lii,lir,lig,lib,lnx1,lny1,lnx2,lny2
      liHeight=liY2-liY1+1
      liWidth=liX2-liX1+1
      FOR lii=0 TO liHeight-1
          This.PutVLine(lii+liY1,liX1,liX2,liColor,.T.)
      NEXT
   ENDPROC

   PROCEDURE FillGradient(liType, liY1,liY2, liX1,liX2, liColor1,liColor2)
      LOCAL liHeight,liWidth,lii,lir,lig,lib,lnx1,lny1,lnx2,lny2
      LOCAL ARRAY laColor1(3), laColor2(3)
      =C2RGB(liColor1,@laColor1)
      =C2RGB(liColor2,@laColor2)

      liHeight=liY2-liY1+1
      liWidth=liX2-liX1+1
      DO CASE
         CASE BITTEST(liType,0) AND BITTEST(liType,1) && oboje
              STORE 0 TO  lnx1,lny1,lnx2,lny2
              This.SetPointColor(liY1,liX1,liColor1,.T.)

              DO WHILE (lnx1 < liWidth AND lny1 < liHeight)
                 IF lny1 < liHeight-1
                    lny1 = lny1 + 1 
                 ELSE
                    lnx1 = lnx1 + 1
                 ENDIF

                 IF lnx2 < liWidth-1
                    lnx2 = lnx2 + 1 
                 ELSE
                    lny2 = lny2 + 1 
                 ENDIF  

                 lii = lnx1+lny1
                 lir = laColor1(1) + (lii * (laColor2(1)-laColor1(1)) / (liWidth+liHeight))
                 lig = laColor1(2) + (lii * (laColor2(2)-laColor1(2)) / (liWidth+liHeight))
                 lib = laColor1(3) + (lii * (laColor2(3)-laColor1(3)) / (liWidth+liHeight))

                 FOR lii=lnY1 TO lnY2 STEP -1
                     This.SetPointColor(liY1+lii,liX1+lnX1+(lnY1-lii),RGB(lir,lig,lib),.T.)
                 NEXT
              ENDDO



         CASE BITTEST(liType,0)&& Top to down
              FOR lii=0 TO liHeight-1
                  lir = laColor1(1) + (lii * (laColor2(1)-laColor1(1)) / liHeight)
                  lig = laColor1(2) + (lii * (laColor2(2)-laColor1(2)) / liHeight)
                  lib = laColor1(3) + (lii * (laColor2(3)-laColor1(3)) / liHeight)
                  This.PutVLine(lii+liY1,liX1,liX2,RGB(lir,lig,lib),.T.)
              NEXT


         CASE BITTEST(liType,1)&& Left to Right
              FOR lii=0 TO liWidth-1
                  lir = laColor1(1) + (lii * (laColor2(1)-laColor1(1)) / liWidth)
                  lig = laColor1(2) + (lii * (laColor2(2)-laColor1(2)) / liWidth)
                  lib = laColor1(3) + (lii * (laColor2(3)-laColor1(3)) / liWidth)
                  This.PutHLine(lii+liX1,liY1,liY2,RGB(lir,lig,lib),.T.)
              NEXT

      ENDCASE
   ENDPROC

   PROCEDURE SetData(lcData)
      This.Data=lcData
   ENDPROC

   PROCEDURE GetData(lcData)
      RETURN This.Data
   ENDPROC

   PROCEDURE SaveToFile(lcFile)
      LOCAL lihFile,lcPom,liLCA
      lihFile=FCREATE(lcFile)
      IF lihFile<=0
         RETURN .F.
      ENDIF
      liLCA=0
      * Zapi hlaviku
      =FWRITE(lihFile,"BM"+REPL(CHR(0),12))

      *BITMAPINFOHEADER
      lcPom=BINTOC(This.biSize,"RS")+;
            BINTOC(This.biWidth,"RS")+;
            BINTOC(This.biHeight,"RS")+;
            BINTOC(This.biPlanes,"2RS")+;
            BINTOC(This.biBitCount,"2RS")+;
            BINTOC(This.biCompression,"RS")+;
            BINTOC(This.biSizeImage,"RS")+;
            BINTOC(This.biXPelsPerMeter,"RS")+;
            BINTOC(This.biYPelsPerMeter,"RS")+;
            BINTOC(This.biClrUsed,"RS")+;
            BINTOC(This.biClrImportant,"RS")

      =FWRITE(lihFile,lcPom)

      IF This.biBitCount=8
         =FWRITE(lihFile,This.ColorArray,LEN(This.ColorArray))
         liLCA=LEN(This.ColorArray)
      ENDIF   
      =FWRITE(lihFile,This.Data,This.biSizeImage)

      * oprava hlaviky
      =FSEEK(lihFile,2) && velikost souboru
      =FWRITE(lihFile,BINTOC(14+This.biSize+liLCA+This.biSizeImage,"RS"))

      =FSEEK(lihFile,10) && offset s daty obrzku
      =FWRITE(lihFile,BINTOC(14+This.biSize+liLCA,"RS"))
      =FCLOSE(lihFile)
   ENDPROC

   PROCEDURE New(liWidth,liHeight,liPallete)
      This.Head="BM"
      This.Reserved1=0
      This.Reserved2=0

      This._Delta=4-liWidth%4
      This._Delta=IIF(This._Delta=4,0,This._Delta)

      This.biSize=40 && DWORD  biSize
      This.biWidth=liWidth && LONG   biWidth 
      This.biHeight=liHeight &&  LONG   biHeight
      This.biPlanes=1 &&  WORD   biPlanes 
      This.biBitCount=liPallete &&  WORD   biBitCount
      This.biCompression=0 &&  DWORD  biCompression
      This.biSizeImage=liHeight*(liWidth+This._Delta)*liPallete/8 &&  DWORD  biSizeImage
      This.biXPelsPerMeter=0 &&  LONG   biXPelsPerMeter
      This.biYPelsPerMeter=0 &&  LONG   biYPelsPerMeter
      This.biClrUsed=0 &&  DWORD  biClrUsed
      This.biClrImportant=0 &&  DWORD  biClrImportant
      
      This.ColorArray=IIF(liPallete=8,REPL(CHR(255),(liPallete/8*256)*4),"")
      This.Data=REPL(CHR(255),This.biSizeImage)
      This._Index=-1
      This.Offset=14+This.biSize+LEN(This.ColorArray)
      This.Size=This.Offset+This.biSizeImage
   ENDPROC

ENDDEFINE


